// TreeDialog.cpp : implementation file
//

#include "stdafx.h"
#include "xmsaalibtest.h"
#include "TreeDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeDialog dialog

BEGIN_MESSAGE_MAP(CTreeDialog, CDialog)
	//{{AFX_MSG_MAP(CTreeDialog)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CTreeDialog::CTreeDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTreeDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTreeDialog)
	//}}AFX_DATA_INIT
}

void CTreeDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTreeDialog)
	DDX_Control(pDX, IDC_TREE1, m_Tree);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CTreeDialog message handlers

BOOL CTreeDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if (::GetFileAttributes(XML_FILE) == INVALID_FILE_ATTRIBUTES)
	{
		CString s = _T("");
		s.Format(_T("Cannot find file '%s'"), XML_FILE);
		AfxMessageBox(s, MB_ICONSTOP);
		EndDialog(-1);
	}

#ifdef _UNICODE
	TRACE(_T("***** Attempting to read UNICODE file %s *****\n"), XML_FILE);
#else
	TRACE(_T("***** Attempting to read ASCII file %s *****\n"), XML_FILE);
#endif

	m_Tree.LoadXmlFromFile(XML_FILE, CXHtmlTree::NoConvertAction);
	m_Tree.ExpandAll();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTreeDialog::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CTreeDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (!::IsWindow(m_Tree.m_hWnd))
		return;

	CRect rectDlg;
	GetClientRect(&rectDlg);
	int h = rectDlg.Height();
	int w = rectDlg.Width();
	
	CRect rectTree;
	m_Tree.GetWindowRect(&rectTree);
	ScreenToClient(&rectTree);

	m_Tree.MoveWindow(0, 0, w, h, TRUE);
}

void CTreeDialog::PreSubclassWindow() 
{
	// add thickframe to allow resizing - doing it 
	// this way avoids having a system menu
	ModifyStyle(0, WS_THICKFRAME);
	
	CDialog::PreSubclassWindow();
}
