// XMSAALibTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XMSAALibTest.h"
#include "XMSAALibTestDlg.h"
#include "about.h"
#include "comutil.h"
#include "TreeDialog.h"
#include "XTrace.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int g_nObjects = 0;
static int g_nPrevLevel = -1;
static CXMSAALibTestDlg *g_pDlg = NULL;
static BOOL g_bFoundAddressBar = FALSE;
static CString g_strAddressBar = _T("");
static CString g_strXml = _T("");

//=============================================================================
BEGIN_MESSAGE_MAP(CXMSAALibTestDlg, CDialog)
//=============================================================================
	//{{AFX_MSG_MAP(CXMSAALibTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_ONLINE_HELP, OnOnlineHelp)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//=============================================================================
CXMSAALibTestDlg::CXMSAALibTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXMSAALibTestDlg::IDD, pParent)
//=============================================================================
{
	//{{AFX_DATA_INIT(CXMSAALibTestDlg)
	m_nBrowser = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pMSAALib = NULL;
}

//=============================================================================
CXMSAALibTestDlg::~CXMSAALibTestDlg()
//=============================================================================
{
	if (m_pMSAALib)
		delete m_pMSAALib;
	m_pMSAALib = NULL;
}

//=============================================================================
void CXMSAALibTestDlg::DoDataExchange(CDataExchange* pDX)
//=============================================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXMSAALibTestDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Radio(pDX, IDC_BROWSER1, m_nBrowser);
	//}}AFX_DATA_MAP
}

//=============================================================================
BOOL CXMSAALibTestDlg::OnInitDialog()
//=============================================================================
{
	CDialog::OnInitDialog();

	g_pDlg = this;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_List.SetTabPosition(4);
	m_List.SetContextMenuId(IDR_XLISTBOX);
	m_List.EnableLineNumbers(TRUE);
	m_List.SetGutterWidth(4);
	m_List.AddLine(CXListBox::Blue, CXListBox::White, _T("XMSAALibTest v1.0"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

//=============================================================================
void CXMSAALibTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
//=============================================================================
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//=============================================================================
void CXMSAALibTestDlg::OnPaint() 
//=============================================================================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//=============================================================================
HCURSOR CXMSAALibTestDlg::OnQueryDragIcon()
//=============================================================================
{
	return (HCURSOR) m_hIcon;
}

//=============================================================================
static void CALLBACK MSAAEventProc(IAccessible *pAccChild, 
								   VARIANT *pvarChild,
								   DWORD event, 
								   HWND hwnd)
//=============================================================================
{
	TRACE(_T("in MSAAEventProc: 0x%X\n"), event);

	if (g_pDlg)
	{
		CString str = _T("");
		str.Format(_T("Event handler:  event=0x%X  hwnd=0x%X"), event, hwnd);
		g_pDlg->m_List.AddLine(CXListBox::Purple, CXListBox::White, str);
		if (pAccChild && pvarChild)
		{
			// name -------------------------------------------------
			str = _T("    Name: ");
			TCHAR szName[100];
			szName[0] = 0;
			CXMSAALib::GetObjectName(pAccChild, pvarChild, szName, 
									 sizeof(szName)/sizeof(TCHAR));
			szName[sizeof(szName)/sizeof(TCHAR)-1] = 0;
			CString strName = szName;
			if (strName.IsEmpty())
				strName = _T("NAMELESS");
			TRACE(_T("   name=<%-100.100s>\n"), strName);
			str += strName;
			g_pDlg->m_List.AddLine(CXListBox::Black, CXListBox::White, str);

			// description ------------------------------------------
			str = _T("    Description: ");
			TCHAR szDescription[1000];
			szDescription[0] = 0;
			CXMSAALib::GetObjectDescription(pAccChild, pvarChild, szDescription,
										   sizeof(szDescription)/sizeof(TCHAR));
			szDescription[sizeof(szDescription)/sizeof(TCHAR)-1] = 0;
			TRACE(_T("   szDescription=<%s>\n"), szDescription);
			if (szDescription[0] == 0)
				str += _T('?');
			else
				str += szDescription;
			g_pDlg->m_List.AddLine(CXListBox::Black, CXListBox::White, str);

			// location ---------------------------------------------
			str = _T("    Location: ");
			CRect rect(0,0,0,0);
			CXMSAALib::GetObjectLocation(pAccChild, pvarChild, rect);
			CString strLoc = _T("");
			strLoc.Format(_T("(%d, %d, %d, %d)"), rect.left, rect.top, rect.right, rect.bottom);
			str += strLoc;
			g_pDlg->m_List.AddLine(CXListBox::Black, CXListBox::White, str);

			// value ------------------------------------------------
			str = _T("    Value: ");
			TCHAR szValue[1000];
			szValue[0] = 0;
			CXMSAALib::GetObjectValue(pAccChild, pvarChild, szValue,
										   sizeof(szValue)/sizeof(TCHAR));
			szValue[sizeof(szValue)/sizeof(TCHAR)-1] = 0;
			TRACE(_T("   szValue=<%s>\n"), szValue);
			if (szValue[0] != 0)
				str += szValue;
			else
				str += _T('?');
			g_pDlg->m_List.AddLine(CXListBox::Black, CXListBox::White, str);
		}
	}
	TRACE(_T("exiting MSAAEventProc\n"));
}

//=============================================================================
static BOOL CALLBACK MSAAEnumProc(IAccessible *pAccChild, 
								  VARIANT *pvarChild,
								  HWND /*hwndChild*/, 
								  int nLevel,
								  LPARAM /*lParam*/)
//=============================================================================
{
	g_nObjects++;
	TRACE(_T("in MSAAEnumProc:  nObjects=%d  nLevel=%d\n"), g_nObjects, nLevel);

	ASSERT(pAccChild);
	ASSERT(pvarChild);
	ASSERT(nLevel >= 0);

	CString str = _T("");
	CString s = _T("");

	while (nLevel <= g_nPrevLevel)
	{
		for (int i = 0; i < g_nPrevLevel; i++)
			g_strXml += _T('\t');

		s.Format(_T("</level_%d>\r\n"), g_nPrevLevel);
		g_strXml += s;
		g_nPrevLevel--;
	}

	g_nPrevLevel = nLevel;

	if (pAccChild && pvarChild)
	{
		// name -----------------------------------------------------
		TCHAR szName[1000];
		szName[0] = 0;
		CXMSAALib::GetObjectName(pAccChild, pvarChild, szName, 
								 sizeof(szName)/sizeof(TCHAR));
		szName[sizeof(szName)/sizeof(TCHAR)-1] = 0;
		CString strName(szName);
		if (strName.IsEmpty())
			strName = _T("NAMELESS");
		TRACE(_T("   name=<%s>\n"), strName);
		str += strName;
		str += _T('[');

		// role -----------------------------------------------------
		TCHAR szRole[100];
		szRole[0] = 0;
		CXMSAALib::GetObjectRoleString(pAccChild, pvarChild, szRole,
									   sizeof(szRole)/sizeof(TCHAR));
		szRole[sizeof(szRole)/sizeof(TCHAR)-1] = 0;
		TRACE(_T("   szRole=<%s>\n"), szRole);
		if (szRole[0] != 0)
			str += szRole;

		// state ----------------------------------------------------
		TCHAR szState[1000];
		CXMSAALib::GetObjectStateString(pAccChild, 
										pvarChild, 
										szState,
										sizeof(szState)/sizeof(TCHAR));
		szState[sizeof(szState)/sizeof(TCHAR)-1] = 0;
		if (szState[0] != 0)
		{
			str += _T(" - ");
			str += szState;
		}

		str += _T(']');

		// description ----------------------------------------------
		str += _T(" {Description: ");
		TCHAR szDescription[1000];
		szDescription[0] = 0;
		CXMSAALib::GetObjectDescription(pAccChild, pvarChild, szDescription,
									   sizeof(szDescription)/sizeof(TCHAR));
		szDescription[sizeof(szDescription)/sizeof(TCHAR)-1] = 0;
		TRACE(_T("   szDescription=<%s>\n"), szDescription);
		if (szDescription[0] == 0)
			str += _T('?');
		else
			str += szDescription;

		// location -------------------------------------------------
		str += _T(", Location: ");
		CRect rect(0,0,0,0);
		CXMSAALib::GetObjectLocation(pAccChild, pvarChild, rect);
		CString strLoc = _T("");
		strLoc.Format(_T("(%d, %d, %d, %d)"), rect.left, rect.top, rect.right, rect.bottom);
		str += strLoc;

		// value ----------------------------------------------------
		str += _T(", Value: ");
		TCHAR szValue[1000];
		szValue[0] = 0;
		CXMSAALib::GetObjectValue(pAccChild, pvarChild, szValue,
									   sizeof(szValue)/sizeof(TCHAR));
		szValue[sizeof(szValue)/sizeof(TCHAR)-1] = 0;
		TRACE(_T("   szValue=<%s>\n"), szValue);
		CString strValue(szValue);
		if (!strValue.IsEmpty())
		{
			strValue.Replace(_T("&"), _T("&amp;"));
			TRACE(_T("   value=<%s>\n"), strValue);
			if (strValue.Find(_T("http")) != -1)
			{
				str += _T("&lt;font color=&quot;red&quot;&gt;");
				str += strValue;
				str += _T("&lt;/font&gt;");
			}
			else
			{
				str += strValue;
			}
		}
		else
		{
			str += _T('?');
		}
		str += _T('}');
	}

	TRACE(_T("str=<%s>\n"), str);
	if (g_pDlg && !str.IsEmpty())
		g_pDlg->m_List.AddString(str);

	CString strXml = _T("");
	for (int i = 0; i < nLevel; i++)
		strXml += _T('\t');
	s = _T("");
	if (!str.IsEmpty())
	{
		str.Replace(_T("<"), _T("&lt;"));
		str.Replace(_T(">"), _T("&gt;"));
		if (nLevel == 0)
			s.Format(_T("<level_%d name=\"&lt;b&gt;&lt;font color=&quot;blue&quot;&gt;%s&lt;/font&gt;&lt;/b&gt;\">\r\n"), nLevel, str);
		else if (nLevel == 1)
			s.Format(_T("<level_%d name=\"&lt;font color=&quot;blue&quot;&gt;%s&lt;/font&gt;\">\r\n"), nLevel, str);
		else
			s.Format(_T("<level_%d name=\"%s\">\r\n"), nLevel, str);
		strXml += s;
		g_strXml += strXml;
		TRACE(_T("length=%d .....\n"), g_strXml.GetLength());
	}
	else
	{
		ASSERT(FALSE);
	}

	return TRUE;	// continue enumeration
}

//=============================================================================
static BOOL CALLBACK MSAAEnumAddressBarProc(IAccessible *pAccChild, 
											VARIANT *pvarChild,
											HWND /*hwndChild*/, 
											int /*nLevel*/,
											LPARAM /*lParam*/)
//=============================================================================
{
	g_nObjects++;
	TRACE(_T("in MSAAEnumAddressBarProc:  nObjects=%d\n"), g_nObjects);

	if (pAccChild && pvarChild)
	{
		// check name
		TCHAR szName[100];
		szName[0] = 0;
		CXMSAALib::GetObjectName(pAccChild, pvarChild, szName, 
								 sizeof(szName)/sizeof(TCHAR));
		szName[sizeof(szName)/sizeof(TCHAR)-1] = 0;

		if (szName[0] != 0)
		{
			if ((_tcsicmp(szName, _T("Address")) != 0) &&
				(_tcsicmp(szName, _T("Location")) != 0))
			{
				// name is not what we're looking for, continue enumeration
				return TRUE;
			}
		}

		// name is either empty (which is ok for Firefox 2 and Opera 10)
		// or contains recognized string
		TCHAR szRole[100];
		szRole[0] = 0;
		CXMSAALib::GetObjectRoleString(pAccChild, pvarChild, szRole,
									   sizeof(szRole)/sizeof(TCHAR));
		szRole[sizeof(szRole)/sizeof(TCHAR)-1] = 0;

		TRACE(_T("szRole=<%s>\n"), szRole);

		if (_tcsnicmp(szRole, _T("editable text"), 
				sizeof(_T("editable text"))/sizeof(TCHAR)) != 0)
		{
			// role is not what we're looking for, continue enumeration
			return TRUE;
		}

		// name and role are ok - check value string for "http"
		TCHAR szValue[1000];
		szValue[0] = 0;
		CXMSAALib::GetObjectValue(pAccChild, pvarChild, szValue, 
								  sizeof(szValue)/sizeof(TCHAR));
		szValue[sizeof(szValue)/sizeof(TCHAR)-1] = 0;

		TRACE(_T("szValue=<%-100.100s>\n"), szValue);
		if (_tcsstr(szValue, _T("http")) == NULL)
		{
			// value is not a web page address, continue enumeration
			return TRUE;
		}
		else
		{
			g_bFoundAddressBar = TRUE;
			g_strAddressBar = szValue;
			return FALSE;	// stop enumeration, found address bar
		}
	}
	return TRUE;
}

//=============================================================================
//=============================================================================
//
//                            BUTTON HANDLERS
//
//=============================================================================
//=============================================================================


//=============================================================================
// Start Event Handler
void CXMSAALibTestDlg::OnButton1() 
//=============================================================================
{
	TRACE(_T("in CXMSAALibTestDlg::OnButton1\n"));
	if (m_pMSAALib)
		delete m_pMSAALib;
	m_pMSAALib = new CXMSAALib;
	ASSERT(m_pMSAALib);
	m_pMSAALib->StartGetObjectFromEvent(MSAAEventProc);
	m_List.AddLine(CXListBox::Blue, CXListBox::White, _T("Event handler started"));
	TRACE(_T("exiting CXMSAALibTestDlg::OnButton1\n"));
}

//=============================================================================
// Stop Event Handler
void CXMSAALibTestDlg::OnButton2() 
//=============================================================================
{
	if (m_pMSAALib)
	{
		m_pMSAALib->StopGetObjectFromEvent();
		delete m_pMSAALib;
		m_pMSAALib = NULL;
		m_List.AddLine(CXListBox::Blue, CXListBox::White, _T("Event handler stopped"));
	}
}

//=============================================================================
// Enum All Browser Objects
void CXMSAALibTestDlg::OnButton3() 
//=============================================================================
{
	TRACE(_T("in CXMSAALibTestDlg::OnButton3\n"));

	UpdateData(TRUE);

	g_strXml = _T("<?xml version=\"1.0\" encoding=\"ISO-8859-15\"?>\r\n");
	g_nPrevLevel = -1;

	TRACE(_T("m_nBrowser=%d\n"), m_nBrowser);

	CXMSAALib MSAALib;
	HWND hwnd = GetBrowserHwnd(m_nBrowser);
	
	if (::IsWindow(hwnd))
	{
		m_List.AddLine(CXListBox::Blue, CXListBox::White, _T("Object enumeration started"));
		g_nObjects = 0;
		MSAALib.EnumAccessible(hwnd, MSAAEnumProc, 0);
		m_List.AddLine(CXListBox::Blue, CXListBox::White, _T("Object enumeration complete"));

		m_List.Printf(CXListBox::Blue, CXListBox::White, 0,
			_T("Writing XML to file %s"), XML_FILE);
		CString s = _T("");

		// close any open xml elements
		while (g_nPrevLevel >= 0)
		{
			for (int i = 0; i < g_nPrevLevel; i++)
				g_strXml += _T('\t');

			s.Format(_T("</level_%d>\r\n"), g_nPrevLevel);
			g_strXml += s;
			g_nPrevLevel--;
		}
		g_strXml += _T("\r\n");

		TRACE(_T("length=%d .....\n"), g_strXml.GetLength());

		// write xml to file
		CFile f(XML_FILE, CFile::modeCreate|CFile::modeWrite|CFile::shareExclusive);
#ifdef _UNICODE
		BYTE BOM[2] = { 0xFF, 0xFE };
		f.Write(BOM, 2);
#endif
		f.Write((LPCTSTR)g_strXml, g_strXml.GetLength()*sizeof(TCHAR));
		f.Close();
	}
	else
	{
		TRACE(_T("ERROR - browser not running\n"));
		m_List.AddLine(CXListBox::Red, CXListBox::White, 
			_T("That browser is not currently running"));
	}
	TRACE(_T("exiting CXMSAALibTestDlg::OnButton3\n"));
}

//=============================================================================
// Display Object Tree
void CXMSAALibTestDlg::OnButton4() 
//=============================================================================
{
	CTreeDialog dlg;
	dlg.DoModal();
}

//=============================================================================
// Get Browser Address Bar
void CXMSAALibTestDlg::OnButton5() 
//=============================================================================
{
	TRACE(_T("m_nBrowser=%d\n"), m_nBrowser);

	UpdateData(TRUE);

	CXMSAALib MSAALib;
	HWND hwnd = GetBrowserHwnd(m_nBrowser);
	
	if (::IsWindow(hwnd))
	{
		g_nObjects = 0;
		g_bFoundAddressBar = FALSE;
		g_strAddressBar = _T("");
		m_List.AddLine(CXListBox::Blue, CXListBox::White, 
			_T("Searching for address bar..."));
		MSAALib.EnumAccessible(hwnd, MSAAEnumAddressBarProc, 0);

		if (g_bFoundAddressBar)
		{
			m_List.Printf(CXListBox::Green, CXListBox::White, 0,
				_T("    Found address bar: <%s>"), g_strAddressBar);
		}
		else
		{
			m_List.AddLine(CXListBox::Red, CXListBox::White, 
				_T("    Failed to find browser address bar"));
		}
	}
	else
	{
		TRACE(_T("ERROR - browser not running\n"));
		m_List.AddLine(CXListBox::Red, CXListBox::White, 
			_T("That browser is not currently running"));
	}
}

//=============================================================================
// Help
void CXMSAALibTestDlg::OnOnlineHelp() 
//=============================================================================
{
	CString strHelp = _T("");
	VERIFY(strHelp.LoadString(IDS_ONLINE_HELP));
	CXHyperLink::GotoURL(strHelp, SW_SHOW, TRUE);	
}

//=============================================================================
HWND CXMSAALibTestDlg::GetBrowserHwnd(int nBrowser)
//=============================================================================
{
	HWND hwnd = NULL;

	CString str = _T("");

	switch (nBrowser)
	{
		default:
		case 0:	
			hwnd = CXMSAALib::GetFirefoxHwnd();
			str = _T("Firefox");
			break;

		case 1:	
			hwnd = CXMSAALib::GetInternetExplorerHwnd();
			str = _T("Internet Explorer");
			break;

		case 2:	
			hwnd = CXMSAALib::GetOperaHwnd();
			str = _T("Opera");
			break;

		case 3:	
			hwnd = CXMSAALib::GetGoogleChromeHwnd();
			str = _T("Google Chrome");
			break;
	}
	if (::IsWindow(hwnd))
		m_List.Printf(CXListBox::Green, CXListBox::White, 0,
			_T("Found %s browser"), str);
	return hwnd;
}
